# -*- coding: utf-8 -*-
#
# BasicTools documentation build configuration file, created by
# sphinx-quickstart on Tue Feb 20 11:03:47 2018.
#
# This file is execfile()d with the current directory set to its containing dir.
#
# Note that not all possible configuration values are present in this
# autogenerated file.
#
# All configuration values have a default; values that are commented out
# serve to show the default.

# Run doxygen for the c++ documentation
import subprocess
subprocess.call('doxygen', shell=True)

import sys, os
# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
sys.path.insert(0, os.path.abspath('..'+os.sep+'src'))

from BasicTools import __name__ as BasicTools__name__
from BasicTools import __copyright__ as BasicTools__copyright__
from BasicTools import __copyright_holder__ as BasicTools__copyright_holder__
from BasicTools import __license__ as BasicTools__license__
from BasicTools import __version__ as BasicTools__version__

# -- General configuration -----------------------------------------------------
# Numbered figures in your Sphinx documents and refer to them by number
numfig = True

# If your documentation needs a minimal Sphinx version, state it here.
#needs_sphinx = '1.0'

# Add any Sphinx extension module names here, as strings. They can be extensions
# coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
extensions = [
        'sphinx.ext.autodoc',
        'sphinx.ext.autosummary',
        'sphinx.ext.napoleon',
        'sphinx.ext.viewcode',
        'sphinx.ext.mathjax',
        'sphinx.ext.todo',
        'sphinx_rtd_theme',
        'breathe'
        ]

breathe_projects = { "BasicToolsCpp": "./xml/" }

#breathe_projects_source = {
#    "BasicToolsCpp" : (
#        "/home/fbordeu-weld/PythonLibs/BasicTools/cpp_src/", [ "/Containers/UnstructuredMesh.h"]
#}    )
#}}

breathe_default_project = "BasicToolsCpp"
breathe_show_include = True
breathe_default_members = ('members', 'undoc-members')


todo_include_todos=True
typehints_fully_qualified = False

# Add any paths that contain templates here, relative to this directory.
templates_path = []

# The suffix of source filenames.
source_suffix = '.rst'

# The encoding of source files.
#source_encoding = 'utf-8-sig'

# The master toctree document.
master_doc = 'index'

# General information about the project.
project = BasicTools__name__
copyright = BasicTools__copyright__

# The version info for the project you're documenting, acts as replacement for
# |version| and |release|, also used in various other places throughout the
# built documents.
#
# The short X.Y version.
version = BasicTools__version__
# The full version, including alpha/beta/rc tags.
release = BasicTools__version__

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#language = None

# There are two options for replacing |today|: either, you set today to some
# non-false value, then it is used:
#today = ''
# Else, today_fmt is used as the format for a strftime call.
#today_fmt = '%B %d, %Y'

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
exclude_patterns = ['_build']

# The reST default role (used for this markup: `text`) to use for all documents.
#default_role = None

# If true, '()' will be appended to :func: etc. cross-reference text.
#add_function_parentheses = True

# If true, the current module name will be prepended to all description
# unit titles (such as .. function::).
#add_module_names = True

# If true, sectionauthor and moduleauthor directives will be shown in the
# output. They are ignored by default.
#show_authors = False

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = 'sphinx'

# A list of ignored prefixes for module index sorting.
modindex_common_prefix = ['BasicTools.']


# -- Options for HTML output ---------------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#html_theme = 'default'
html_theme = 'sphinx_rtd_theme'

# Theme options are theme-specific and customize the look and feel of a theme
# further.  For a list of options available for each theme, see the
# documentation.
#html_theme_options = {}

# Add any paths that contain custom themes here, relative to this directory.
#html_theme_path = []

# The name for this set of Sphinx documents.  If None, it defaults to
# "<project> v<release> documentation".
#html_title = None

# A shorter title for the navigation bar.  Default is the same as html_title.
#html_short_title = None

# The name of an image file (relative to this directory) to place at the top
# of the sidebar.
#html_logo = None

# The name of an image file (within the static path) to use as favicon of the
# docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
# pixels large.
#html_favicon = None

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ['_static']

# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
# using the given strftime format.
#html_last_updated_fmt = '%b %d, %Y'

# If true, SmartyPants will be used to convert quotes and dashes to
# typographically correct entities.
#html_use_smartypants = True

# Custom sidebar templates, maps document names to template names.
#html_sidebars = {}

# Additional templates that should be rendered to pages, maps page names to
# template names.
#html_additional_pages = {}

# If false, no module index is generated.
#html_domain_indices = True

# If false, no index is generated.
#html_use_index = True

# If true, the index is split into individual pages for each letter.
#html_split_index = False

# If true, links to the reST sources are added to the pages.
#html_show_sourcelink = True

# If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
#html_show_sphinx = True

# If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
#html_show_copyright = True

# If true, an OpenSearch description file will be output, and all pages will
# contain a <link> tag referring to it.  The value of this option must be the
# base URL from which the finished HTML is served.
#html_use_opensearch = ''

# This is the file name suffix for HTML files (e.g. ".xhtml").
#html_file_suffix = None

# Output file base name for HTML help builder.
htmlhelp_basename = 'BasicToolsdoc'


# -- Options for LaTeX output --------------------------------------------------

latex_elements = {
# The paper size ('letterpaper' or 'a4paper').
#'papersize': 'letterpaper',

# The font size ('10pt', '11pt' or '12pt').
#'pointsize': '10pt',

# Additional stuff for the LaTeX preamble.
#'preamble': '',
}

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title, author, documentclass [howto/manual]).
latex_documents = [
  ('index', 'BasicTools.tex', u'BasicTools Documentation',
   BasicTools__copyright_holder__, 'manual'),
]

# The name of an image file (relative to this directory) to place at the top of
# the title page.
#latex_logo = None

# For "manual" documents, if this is true, then toplevel headings are parts,
# not chapters.
#latex_use_parts = False

# If true, show page references after internal links.
#latex_show_pagerefs = False

# If true, show URL addresses after external links.
#latex_show_urls = False

# Documents to append as an appendix to all manuals.
#latex_appendices = []

# If false, no module index is generated.
#latex_domain_indices = True


# -- Options for manual page output --------------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    ('index', 'basictools', u'BasicTools Documentation',
     [BasicTools__copyright_holder__], 1)
]

# If true, show URL addresses after external links.
#man_show_urls = False


# -- Options for Texinfo output ------------------------------------------------

# Grouping the document tree into Texinfo files. List of tuples
# (source start file, target name, title, author,
#  dir menu entry, description, category)
texinfo_documents = [
  ('index', 'BasicTools', u'BasicTools Documentation',
   BasicTools__copyright_holder__, BasicTools__name__,
   'Tools for finite element computations.',
   'Engineering'),
]

# Documents to append as an appendix to all manuals.
#texinfo_appendices = []

# If false, no module index is generated.
#texinfo_domain_indices = True

# How to display URL addresses: 'footnote', 'no', or 'inline'.
#texinfo_show_urls = 'footnote'

# -- Options for autodoc extension
#autodoc_mock_imports = ['BasicTools']

autodoc_type_aliases = {
    'Iterable': 'Iterable',
    'ArrayLike': 'ArrayLike',
    'np.typing.ArrayLike':'ArrayLike',
    'numpy.float64':'float64'
}

# -- Options for autosummary extension
autosummary_generate = False
autodoc_typehints_format = 'short'
# -- Options for napoleon extension
#pass

# -- Options for viewcode extension
#pass

def run_apidoc(_):
    import sphinx.ext.apidoc
    import os
    import sys
    sys.path.append(os.path.join(os.path.dirname(__file__), '../src/BasicTools'))
    cur_dir = os.path.abspath(os.path.dirname(__file__))
    target_dir = os.path.join(cur_dir, '_source')
    module = os.path.join(cur_dir, '../src/BasicTools')
    sphinx.ext.apidoc.main(['-T', '-M', '-e', '-f', '-o', target_dir, module])

def setup(app):
    app.connect('builder-inited', run_apidoc)
    app.add_css_file('my_theme.css')


# Additional stuff for the LaTeX preamble.


mathjax3_config = {
    "tex": {
        "macros": {
            "RR": '{\\bf R}',

			 "KFE": r'{\mathbf{K}}',
             "UFE": r'{\mathbf{u}}',
             "FFE": r'{\mathbf{f}}',

             "CFE": r'{\mathbf{C}}',
             "GFE": r'{\mathbf{g}}',

             "CPFE": r"{\mathbf{C'}}",

             "MFE": r'{\mathbf{M}}',
             "VFE": r'{\mathbf{v}}',

             "XFE": r'{\mathbf{X}}',
             "DFE": r'{\mathbf{d}}',
             "bold": ['{\\bf #1}',1]
            }
        }
    }

